config/routes.rb
Rails.application.routes.draw do
  root 'movies#index'
  
  devise_for :users, controllers: { registrations: "users/registrations" }
  
  resources :movies

  resources :celeb_users, only: [:show, :new, :create, :edit, :update, :destroy] do
    collection do
      get :actors
      get :producers
      get :directors
    end
  end

  # version 1
  api_version(:module => "V1", :path => {:value => "v1"}, :defaults => {:format => :json}) do

    mount_devise_token_auth_for 'User', at: 'users', controllers: { registrations: 'v1/users/registrations' }

    resources :movies

    resources :celeb_users, only: [:show, :new, :create, :edit, :update, :destroy] do
      collection do
        get :actors
        get :producers
        get :directors
      end
    end
  end
end

app/controllers/movies_controller.rb
class MoviesController < ApplicationController
  before_action :authenticate_user!, except: [:show, :index]
  before_action :authenticate_user_as_admin, only: [:new, :create, :update, :destroy]
  before_action :set_movie, only: [:show, :edit, :update, :destroy]
  serialization_scope :view_context

  def index
    @movies = Movie.all
  end

  def show
  end

  def new
    @movie = Movie.new
  end

  def edit
  end

  def create
    @movie = Movie.new(movie_params)

    if @movie.save
      redirect_to @movie, notice: 'Movie was successfully created.'
    else
      render :new
    end
  end

  def update
    if @movie.update(movie_params)
      redirect_to @movie, notice: 'Movie was successfully updated.'
    else
      render :edit
    end
  end

  def destroy
    @movie.destroy
      redirect_to movies_url, notice: 'Movie was successfully destroyed.'
  end

  private
    def set_movie
      @movie = Movie.find(params[:id])
    end

    def movie_params
      params.require(:movie).permit(:title, :release_year, 
                                    actor_movies_attributes: [:id, :celeb_user_id, :_destroy], 
                                    producer_movies_attributes: [:id, :celeb_user_id, :_destroy], 
                                    director_movies_attributes: [:id, :celeb_user_id, :_destroy])
    end
end

app/controllers/v1/movies_controller.rb
class V1::MoviesController < V1::BaseController
  before_action :authenticate_user!, except: [:show, :index]
  before_action :authenticate_user_as_admin, only: [:new, :create, :update, :destroy]
  before_action :set_movie, only: [:show, :edit, :update, :destroy]
  serialization_scope :view_context

  def index
    @movies = Movie.all
    render json: @movies
  end

  def show
    render json: @movie
  end

  def new
    @movie = Movie.new
  end

  def edit
  end

  def create
    @movie = Movie.new(movie_params)

    if @movie.save
      render json: @movie
    else
      render json: @movie.errors, status: :unprocessable_entity
    end
  end

  def update
    if @movie.update(movie_params)
      render json: @movie
    else
      render json: @movie.errors, status: :unprocessable_entity
    end
  end

  def destroy
    @movie.destroy
    render json: {success: true, message: "Movie has been removed successfully."}
  end

  private
    def set_movie
      @movie = Movie.find(params[:id])
    end

    def movie_params
      params.require(:movie).permit(:title, :release_year, 
                                    actor_movies_attributes: [:id, :celeb_user_id, :_destroy], 
                                    producer_movies_attributes: [:id, :celeb_user_id, :_destroy], 
                                    director_movies_attributes: [:id, :celeb_user_id, :_destroy])
    end
end

app/helpers/movies_helper.rb
module MoviesHelper
end

app/views/movies/_form.html.haml
= nested_form_for @movie do |f|
  - if @movie.errors.any?
    #error_explanation
      %h2= "#{pluralize(@movie.errors.count, "error")} prohibited this movie from being saved:"
      %ul
        - @movie.errors.full_messages.each do |message|
          %li= message
  .form-group
    = f.label :title, class: "col-sm-1 control-label text-left-imp"
    .col-sm-11
      = f.text_field :title, class: "form-control"
  .form-group
    = f.label "Release Year", class: "col-sm-1 control-label text-left-imp"
    .col-sm-11
      = f.text_field :release_year, class: "form-control"
  %hr
  %h3 Actors
  .box-body
    = f.fields_for :actor_movies do |ff|
      .form-group
        = ff.label :actor, class: "col-sm-1 control-label text-left-imp"
        .col-sm-11
          = ff.collection_select :celeb_user_id, CelebUser.actors, :id, :full_name, {include_blank: "Select Actor"}, class: "form-control"
        .actor-remove-btn{title: "Remove Actor"}
          = ff.link_to_remove do
            .btn.btn-default
              %i.fa.fa-trash-o
                %span.btn-text Remove
    .actor-add-btn
      = f.link_to_add :actor_movies, class: "btn btn-default" do
        Add Actor
        %i.fa.fa-plus-circle
  %hr
  %h3 Producers
  .box-body
    = f.fields_for :producer_movies do |ff|
      .form-group
        = ff.label :producer, class: "col-sm-1 control-label text-left-imp"
        .col-sm-11
          = ff.collection_select :celeb_user_id, CelebUser.producers, :id, :full_name, {include_blank: "Select Producer"}, class: "form-control"
        .producer-remove-btn{title: "Remove Producer"}
          = ff.link_to_remove do
            .btn.btn-default
              %i.fa.fa-trash-o
                %span.btn-text Remove
    .actor-add-btn
      = f.link_to_add :producer_movies, class: "btn btn-default" do
        Add Producer
        %i.fa.fa-plus-circle
  %hr
  %h3 Directors
  .box-body
    = f.fields_for :director_movies do |ff|
      .form-group
        = ff.label :director, class: "col-sm-1 control-label text-left-imp"
        .col-sm-11
          = ff.collection_select :celeb_user_id, CelebUser.directors, :id, :full_name, {include_blank: "Select Actor"}, class: "form-control"
        .director-remove-btn{title: "Remove Director"}
          = ff.link_to_remove do
            .btn.btn-default
              %i.fa.fa-trash-o
                %span.btn-text Remove
    .actor-add-btn
      = f.link_to_add :director_movies, class: "btn btn-default" do
        Add Director
        %i.fa.fa-plus-circle
  .actions
    = f.submit 'Save'

app/views/movies/edit.html.haml
%h1 Editing movie

= render 'form'

= link_to 'Show', @movie
\|
= link_to 'Back', movies_path

app/views/movies/index.html.haml
%h1 Movies List

- if @movies.present?
  %table
    %thead
      %tr
        %th Title
        %th Release Date
        %th
        %th
        %th

    %tbody
      - @movies.each do |movie|
        %tr
          %td= movie.title.titleize
          %td= RomanNumerals.to_roman(movie.release_year)
          %td= link_to 'Show', movie
          - if current_user && current_user.admin?
            %td= link_to 'Edit', edit_movie_path(movie)
            %td= link_to 'Destroy', movie, method: :delete, data: { confirm: 'Are you sure?' }
- else
  %h3 There are no movies yet.
%br
- if current_user && current_user.admin?
  = link_to 'New Movie', new_movie_path

app/views/movies/new.html.haml
%h1 New movie

= render 'form'

= link_to 'Back', movies_path

app/views/movies/show.html.haml
.row
  .col-lg-12.col-xs-6
    .box
      .box-header.with-border
        %h3.box-title
          %b= @movie.title.titleize
      .box-body
        %h5 Casting:
        %ul
          - @movie.casting.each do |actor|
            %li= link_to actor.full_name.titleize, celeb_user_path(actor)
        %hr
        %h5 Directors:
        %ul
          - @movie.directors.each do |director|
            %li= link_to director.full_name.titleize, celeb_user_path(director)
        %hr
        %h5 Producers:
        %ul
          - @movie.producers.each do |producer|
            %li= link_to producer.full_name.titleize, celeb_user_path(producer)

- if current_user && current_user.admin?
  = link_to 'Edit Movie Details', edit_movie_path(@movie)